#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <decoder.h>
#include <errno.h>

#include "font.h"


int imagenum=0;

/*void write_image()
{
	char buffer[25];
	FILE *fp;
	sprintf(buffer,"img-%08d.ppm",imagenum);
	printf("Write image: %s\n",buffer);
	imagenum=imagenum+1;
	fp = fopen( buffer , "w" );
	sprintf(buffer, "P4 %d %d\n", WIDTH, HEIGHT);
	fwrite(buffer,1,strlen(buffer),fp);
	fwrite(image, 1,FBLEN,fp);
	fclose(fp);
}*/

uint16_t read_position(BDG_IMAGE *img)
{
	int a=0;
	int b=0;
	a=img->gc(0);
	b=img->gc(0);
	return (b<<8)|(a);
}

static void setbyte(BDG_IMAGE *img, int pos, uint8_t p)
{
	if (img==NULL) return;
	int fblen=img->width*img->height;
	if (pos>=fblen) return;
	img->img[pos]=p^img->xormask;
}

static void fill_pattern(BDG_IMAGE *img, int num)
{
	uint8_t p=img->gc(0);
	if (img==NULL) return;
	int n;
	for (n=0;n<num; n++){
		setbyte(img,img->position,p);
		img->position=img->position+1;
	}
}

static void write_pattern(BDG_IMAGE *img, int num)
{
	int n;
	for (n=0;n<num; n++){
		setbyte(img,img->position,img->gc(0));
		img->position=img->position+1;
	}
}

static void copy_pattern(BDG_IMAGE *img, int num)
{
	uint16_t ps=read_position(img);
	uint16_t pd=img->position;
	int n;
	if (pd>=ps) {
		for (n=0;n<num;n++) setbyte(img,pd+n,img->img[ps+n]);
	} else {
		for (n=num-1;n<0;n++) setbyte(img,pd+n,img->img[ps+n]);
	}
	img->position=img->position+num;
}

static void write_block(BDG_IMAGE *img, uint64_t block)
{
	int n;
	for (n=0;n<8;n++) {
		uint8_t b=block>>(n*8)&0xff;
		setbyte(img,img->position+n*img->width,b);
	}
	img->position=img->position+1;
}

static void write_blk(BDG_IMAGE *img)
{
	int n;
	uint64_t b=0;
	for (n=0;n<8;n++) {
		int c=img->gc(0);
		b=(b<<8)|c;
	}
	write_block(img,b);
}

static void clear_screen(BDG_IMAGE *img)
{
	if (img==NULL) return;
	int n;
	int FBLEN=img->width*img->height;
	for (n=0;n<FBLEN;n++) {
		setbyte(img,n,0);
	}
	img->position=0;
}

void set_position(BDG_IMAGE *img)
{
	img->position=read_position(img);
}


void set_resolution(BDG_IMAGE *img, int w, int h)
{
	if (img==NULL) return;
	if (img->img!=NULL) free(img->img);
	img->img=malloc(w*h);
	img->width=w;
	img->height=h;
}

void write_number(BDG_PUTC pc,int n)
{
	if (n<0) {
		pc('-');
		write_number(pc,-n);
	}
	if (n>=10) {
		write_number(pc,n/10);
		pc('0'+n%10);
	} else pc('0'+n);
}

void write_resolution(BDG_IMAGE *img)
{
	img->pc(BDG_STX);
	img->pc('B'); //bilevel image
	img->pc(' '); //space
	write_number(img->pc,img->width);	
	img->pc(' '); //space
	write_number(img->pc,img->height);
	img->pc(BDG_ETX);
}

int decode(BDG_IMAGE *img)  {
	if (img==NULL) return 0;
	int c=0;
	c=img->gc(1);
	if (c==-2) return -1; //return as there is no data
	if (c==-1) return 0; //no more data
	if (c<128) write_block(img, blocks[c]); else
	if (c==BDG_INQ) { //redraw picture
		img->pc(BDG_ACK); //send ACK to avoid buffer bloat
		return 1; //return and tell software to refresh
	} else
	if (c==BDG_CLRSCR) clear_screen(img); else
	if (c==BDG_INQRES) write_resolution(img); else
	if (c==0xfe) write_blk(img); else
	if (c==0xfd) set_position(img); else
	if (c==0xfb) img->xormask=img->gc(0); else
	if ((c&0xe0)==0x80) fill_pattern(img, (c&0x1f) +1); else
	if ((c&0xe0)==0xa0) copy_pattern(img, (c&0x1f) +1); else
	if ((c&0xe0)==0xc0) write_pattern(img, (c&0x1f)+1);
	return 2;
}
