//#PRAGMA ONCE

#include <stdint.h>

#define BDG_STX (2)
#define BDG_ETX (3)
#define BDG_ACK (6)
#define BDG_INQ (0xff)
#define BDG_INQRES (0xf7)
#define BDG_CLRSCR (0xfc)

typedef int (*BDG_GETC)();
/* Reads a character from the network socket
 * int=0: block if there is no character and wait for it
 * int=1: return EOF if there is no character
 */

typedef void (*BDG_PUTC)(int);

typedef struct{
	int width;
	int height;
	uint8_t xormask;
	int position;
	BDG_GETC gc;
	BDG_PUTC pc;
	uint8_t *img;
} BDG_IMAGE;

void set_resolution(BDG_IMAGE *img, int w, int h);
int decode(BDG_IMAGE *img);
